function fea = im_sky_feature_extraction(im,mask)

patchSize = 15;
gridSpacing = 3;
threshold = 1;
[im_h, im_w, ~] = size(im);       
remX = mod(im_w-patchSize,gridSpacing);
offsetX = floor(remX/2)+1;
remY = mod(im_h-patchSize,gridSpacing);
offsetY = floor(remY/2)+1;
[gridX,gridY] = meshgrid(offsetX:gridSpacing:im_w-patchSize+1, offsetY:gridSpacing:im_h-patchSize+1);


label_arr = sp_find_label_grid(gridX, gridY,mask, patchSize);
hsv_arr = sp_find_HSV_grid(im, gridX, gridY, patchSize);


sift_arr = sp_find_sift_grid(rgb2gray(im), gridX, gridY, patchSize);

[sift_arr, siftlen] = sp_normalize_sift(sift_arr, threshold);

X = [sift_arr,hsv_arr];
Y = label_arr;

pos = find(Y==0);

X(pos,:) = [];
Y(pos,:) = [];

fea.X = X;
fea.Y = Y;

end
