function [skyPatch,nonPatch] = sky_sampling(im,mask)

im = im2uint8(im);
boundary = double(conv2(double(edge(mask,'sobel')),ones(7),'same') > 0.5);
step1 = round(linspace(8, size(im,1)-7,180));
step2 = round(linspace(8, size(im,2)-7,180));
v = 7;
kkSky = 0;
kkNon = 0;

skyPatch{1}.patch = -1;
skyPatch{1}.pos = [-1,-1];

nonPatch{1}.patch = -1;
nonPatch{1}.pos = [-1,-1];

for ii = 1 : length(step1)
    for jj = 1 : length(step2)
        
      c1 = step1(ii);
      c2 = step2(jj);
      if 0 == boundary(c1,c2)
          
          if 1 == mask(c1,c2)
              kkSky = kkSky + 1;
               
              skyPatch{kkSky}.patch = im((c1-v):(c1+v),(c2-v):(c2+v),:);
              skyPatch{kkSky}.pos = [c1,c2];
          else
              kkNon = kkNon + 1;
              
              nonPatch{kkNon}.patch = im((c1-v):(c1+v),(c2-v):(c2+v),:);
              nonPatch{kkNon}.pos = [c1,c2];
          end
      end
      
    end
end

 
end